<?php

/**
 * $arg=[
 * "titles"=>[]
 *  "apiurl"=>
 *"catgory"=>
 * 
 */



function tm_aiwriter_api()
{

    $h = json_decode(json_encode(tm_getallheaders()), true);
    if (!empty($h["X-Wp-Nonce"])) {
        if (!wp_verify_nonce($h['X-Wp-Nonce'], 'wp_rest')) {
            return 'nonce err';
        }
    } else {
        return 'no nonce';
    }
    $arg = $_POST;
    $page_meta = get_post_meta($arg['page_id'], "tm_aiwriter_page_meta", true);
    //return $page_meta;
    if (empty(trim($page_meta['agent']))) {
        $q = $arg['prompt'];
    } else {
        $q = str_replace("[prompt]", $arg['prompt'], $page_meta['agent']);
    }
    if (!empty($arg['language'])) {
        $q = $q . " Use " . $arg['language'];
    }
    $save = false;
    if ($page_meta['save'] == 'true') {
        $save = true;
    }
    if ($arg['userid'] == false) {
        $userid = $page_meta['default_user'];
    } else {
        $userid = $arg['userid'];
    }
    $data = [
        "post_title" => $arg['prompt'], //$titles[$i],
        "q" => $q,
        "userid" => $userid,
        "post_category" => [(int)$page_meta["category"]],
        "post_status" => $page_meta["status"],
        // "post_type" => $arg["post_type"],

        "flow" => ["save"],
        "is_auto_save" => $save
    ];
    //return $data;
    $res = tm_aiwriter_ggai_run($data);
    return $res;
}
function tm_aiwriter_api_route()
{
    register_rest_route(
        'tm/v1',
        'aiwriter',
        array(
            array(
                'methods' => "POST",
                'callback' => 'tm_aiwriter_api',
                'permission_callback' => '__return_true',

            ),
        )
    );
}
add_action('rest_api_init', 'tm_aiwriter_api_route');



/* function tm_aiwriter_get_title($arg, $aires)
{

    $titles = preg_split("/\r\n|\n|\r/", $aires[0]->text);

    $title = str_replace("*", " ", $titles[0]);
    $title = str_replace("#", " ", $title);
    $title = str_replace("Title:", " ", $title);

    $title = trim($title);
    // return $title;
    // exit();
    //
    $arg["post_title"] = $title;

    return $arg;
} */




function tm_aiwriter_ggai_run($arg)
{
    if (!empty($arg['q'])) {
        /*   $isproxy = get_option("tm_aiwriter_isproxy");
           // return $isproxy;
            if ($isproxy == "on") {
               // return $arg['q'];
              //  $res = tm_aiwriter_get_ggai_fun(); 
                       $url = get_option("tm_aiwriter_proxy") . "?q=" . $arg['q'];
                       //return $url;
        $res =   tm_aiwriter_get($url);

            } else { */
        $res = tm_aiwriter_ggai_fun($arg['q']);
        // }
        if (!class_exists('Parsedown')) {
            include_once 'parsedown.php';
        }
        if (!empty($res[0]->text)) {
            $Parsedown = new Parsedown();
            $content = $Parsedown->text($res[0]->text);

           /*  for ($i = 0; $i < count($arg["flow"]); $i++) {

                if ($arg["flow"][$i] == "get_title") {
                    $arg = tm_aiwriter_get_title($arg, $res);
                    // return $arg;
                } else {
                  //  tm_aiwriter_save_generate_text_fun($arg, $res, $content);
                }
            } */
            $res['content'] = $content;
            return $res;
        } else {
            return "no answer";
        }
    } else {
        return "no q";
    }
}


function tm_aiwriter_ggai_fun($text, $modal = '')
{
    $apikey = get_option("tm_ggai_apikey");
    if (empty($apikey)) {
        return "no apikey";
    }
    if ($modal == "gemini-pro-vision") {

        $url = "https://generativelanguage.googleapis.com/v1beta/models/gemini-pro-vision:generateContent?key=" . $apikey;
    } else {
        $url = "https://generativelanguage.googleapis.com/v1beta/models/gemini-pro:generateContent?key=" . $apikey;
        $data = [
            "contents" => [
                "parts" => [
                    "text" => $text
                ]

            ]
        ];
    }

    $res = tm_aiwriter_post($url, json_encode($data));

    return $res->candidates[0]->content->parts;
}
function tm_aiwriter_get($url)
{
    //初始化
    $curl = curl_init();
    //设置抓取的url
    curl_setopt($curl, CURLOPT_URL, $url);
    //设置头文件的信息作为数据流输出
    curl_setopt($curl, CURLOPT_HEADER, 1);
    //设置获取的信息以文件流的形式返回，而不是直接输出。
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    //执行命令
    $data = curl_exec($curl);
    //关闭URL请求
    curl_close($curl);
    //显示获得的数据
    return $data;
}

function tm_aiwriter_post($url, $data = '', $header = ['Content-Type: application/json'])
{
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    // 设置请求头
    curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
    if (!empty($data)) { //判断是否为POST请求
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
    }
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    $response = curl_exec($curl);
    $res = json_decode($response);
    curl_close($curl);
    return $res;
}
if (!function_exists('tm_getallheaders')) {
    function tm_getallheaders()
    {
        $headers = array();
        foreach ($_SERVER as $name => $value) {
            if (substr($name, 0, 5) == 'HTTP_') {
                $headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
            }
        }
        return $headers;
    }
}
