<?php
//禁止直接访问
if (!defined('ABSPATH')) exit;



//metabox
function tm_aiwriter_page_metabox()
{
    add_meta_box('tm_aiwriter_page_metabox', 'AI Writer Shortcode Setting', 'tm_aiwriter_page_render_metabox', 'page', 'side', 'low', array(
        '__block_editor_compatible_meta_box' => true,
    ));
}
add_action('add_meta_boxes', 'tm_aiwriter_page_metabox');
function tm_aiwriter_page_metabox_defaults()
{
    return array(

        'agent' => '',
        'save' => 'false',
        'label' => 'Prompt',
        'status' => 'draft',
        'category' => '1',
        'default_user' => get_current_user_id(),
        'login' => 'false'

    );
}
function tm_aiwriter_page_render_metabox()
{
    // Variables
    global $post; // Get the current post data
    $saved = get_post_meta($post->ID, 'tm_aiwriter_page_meta', true); // Get the saved values
    $defaults = tm_aiwriter_page_metabox_defaults(); // Get the default values
    $details = wp_parse_args($saved, $defaults); // Merge the two in case any fields don't exist in the saved data
    // print_r($details);
?>

    <fieldset>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">
            <div class="misc-pub-section misc-pub-section-last">

                Use [tm_aiwriter] in this page. <a href="https://www.lyustu.com/wordpress-ai-writer/shortcode/" target="_blank">How to setting?</a>
            </div>
        </div>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">

            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('AI Agent:', 'themoon');
                    ?>
                </label>
                <br />
                <textarea name="tm_aiwriter_page_custom_metabox[agent]"><?php echo $details['agent']; ?></textarea>
                <p style="color: #959595; ">*
                    <?php _e('Available prompt word template tags:[prompt]. You must use [prompt] in AI Agent. Example:', 'themoon'); ?></p>
                <p style="color: #959595;">
                    <?php _e('You are a Writer. Write a blog about [prompt].', 'themoon'); ?></p>

            </div>
        </div>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">
            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('Prompt textarea Label:', 'themoon');
                    ?>
                </label>
                <br />
                <input type="text" name="tm_aiwriter_page_custom_metabox[label]" value="<?php echo $details['label'];  ?>">
            </div>
        </div>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">
            <div class="misc-pub-section misc-pub-section-last">

                Here are the pro features: <a href="https://www.lyustu.com/wordpress-ai-writer/" target="_blank">Buy Wordpress AI Writer Pro</a>
            </div>
        </div>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">
            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('Auto Save Generated content?', 'themoon');
                    ?>
                </label>
                <br />
                <input type="radio" name="tm_aiwriter_page_custom_metabox[save]" disabled value="true" <?php checked($details['save'], 'true');  ?>>True
                <input type="radio" name="tm_aiwriter_page_custom_metabox[save]" disabled value="false" <?php checked($details['save'], 'false');  ?>>False
            </div>
        </div>
        <!--<form name="tm_aiwriter_page_form" method="post" runat="server">-->

        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">

            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('Post Status:', 'page');
                    ?>
                </label>
                <br />
                <span style="padding: 10px;"><input type="radio" name="tm_aiwriter_page_custom_metabox[status]" disabled value="draft" <?php checked($details['status'], 'draft');  ?>>Draft<br /></span>
                <span style="padding: 10px;"><input type="radio" name="tm_aiwriter_page_custom_metabox[status]" disabled value="publish" <?php checked($details['status'], 'publish');  ?>>Publish<br /></span>

            </div>
        </div>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">

            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('Post Category:', 'page');
                    ?>
                </label>
                <br />
                <input type="text" name="tm_aiwriter_page_custom_metabox[category]" disabled value="<?php echo $details['category'];  ?>">

            </div>
        </div>

        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">

            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('Default User ID:', 'page');
                    ?>
                </label>
                <br />
                <input type="text" name="tm_aiwriter_page_custom_metabox[default_user]" disabled value="<?php echo $details['default_user'];  ?>">

            </div>
        </div>
        <div style="margin:5px;width:95%;height:95%;border:1px solid #ddd;background:#f1f1f1">
            <div class="misc-pub-section misc-pub-section-last">
                <label>
                    <?php
                    // This runs the text through a translation and echoes it (for internationalization)
                    _e('Is Require Login?', 'themoon');
                    ?>
                </label>
                <br />
                <input type="radio" name="tm_aiwriter_page_custom_metabox[login]" disabled value="true" <?php checked($details['login'], 'true');  ?>>True
                <input type="radio" name="tm_aiwriter_page_custom_metabox[login]" disabled value="false" <?php checked($details['login'], 'false');  ?>>False
            </div>
        </div>

    </fieldset>

<?php
    wp_nonce_field('tm_aiwriter_page_form_metabox_nonce', 'tm_aiwriter_page_form_metabox_process');
}
function tm_aiwriter_page_save_metabox($post_id, $post)
{
    // Verify that our security field exists. If not, bail.
    if (!isset($_POST['tm_aiwriter_page_form_metabox_process'])) return;
    // Verify data came from edit/dashboard screen
    if (!wp_verify_nonce($_POST['tm_aiwriter_page_form_metabox_process'], 'tm_aiwriter_page_form_metabox_nonce')) {
        return $post->ID;
    }
    // Verify user has permission to edit post
    if (!current_user_can('edit_post', $post->ID)) {
        return $post->ID;
    }
    // Check that our custom fields are being passed along
    // This is the `name` value array. We can grab all
    // of the fields and their values at once.
    if (!isset($_POST['tm_aiwriter_page_custom_metabox'])) {
        return $post->ID;
    }
    /**
     * Sanitize all data
     * This keeps malicious code out of our database.
     */
    // Set up an empty array
    //$sanitized = array();
    // Loop through each of our fields
    foreach ($_POST['tm_aiwriter_page_custom_metabox'] as $key => $detail) {
        // Sanitize the data and push it to our new array
        // `wp_filter_post_kses` strips our dangerous server values
        // and allows through anything you can include a post.
        $sanitized[$key] = wp_filter_post_kses($detail);
    }
    // Save our submissions to the database
    update_post_meta($post->ID, 'tm_aiwriter_page_meta', $sanitized);
}
add_action('save_post', 'tm_aiwriter_page_save_metabox', 11, 2);
?>